// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2002-2004 - INRIA - Vincent COUVERT
//
// Copyright (C) 2012 - 2016 - Scilab Enterprises
//
// This file is hereby licensed under the terms of the GNU GPL v2.0,
// pursuant to article 5.3.4 of the CeCILL v.2.1.
// This file was originally licensed under the terms of the CeCILL v2.1,
// and continues to be available under such terms.
// For more information, see the COPYING file which you should have received
// along with this program.

function [tree]=sci_lower(tree)
    // M2SCI function
    // Conversion function for Matlab lower()
    // Input: tree = Matlab funcall tree
    // Output: tree = Scilab equivalent for tree
    // Emulation function: mtlb_lower()

    opt=part("lower",1)

    A = getrhs(tree)
    if A.vtype==String then
        tree.name="convstr"
        tree.rhs=Rhs_tlist(A,opt)
        tree.lhs(1).dims=A.dims
        tree.lhs(1).type=A.type
    elseif A.vtype==Unknown then
        tree.name="mtlb_lower"
        tree.lhs(1).dims=A.dims
        tree.lhs(1).type=A.type
    else
        if typeof(A)=="funcall" then
            A.lhs=tree.lhs
        elseif typeof(A)=="operation" then
            A.out=tree.lhs
        end
        tree=A
    end
endfunction
